diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/eht-frame-exchange-manager.cc ns-3.44/src/wifi/model/eht/eht-frame-exchange-manager.cc
--- ns-3.43/src/wifi/model/eht/eht-frame-exchange-manager.cc	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/eht-frame-exchange-manager.cc	2025-03-09 16:55:49.787372600 -0700
@@ -182,22 +182,24 @@
 
             // EMLSR clients involved in a DL or UL TXOP on another link
             std::set<Mac48Address> emlsrClients;
+            auto ehtFem =
+                StaticCast<EhtFrameExchangeManager>(m_mac->GetFrameExchangeManager(linkId));
 
             // check if an EMLSR client is the holder of an UL TXOP on the other link
-            if (auto ehtFem =
-                    StaticCast<EhtFrameExchangeManager>(m_mac->GetFrameExchangeManager(linkId));
-                ehtFem->m_ongoingTxopEnd.IsPending() && ehtFem->m_txopHolder &&
+            if (ehtFem->m_ongoingTxopEnd.IsPending() && ehtFem->m_txopHolder &&
                 m_mac->GetWifiRemoteStationManager(linkId)->GetEmlsrEnabled(
                     ehtFem->m_txopHolder.value()))
             {
+                NS_LOG_DEBUG("Involved in UL TXOP: " << ehtFem->m_txopHolder.value());
                 emlsrClients.insert(ehtFem->m_txopHolder.value());
             }
 
             // check if EMLSR clients are involved in a DL TXOP on another link
-            for (const auto& address : m_protectedStas)
+            for (const auto& address : ehtFem->m_protectedStas)
             {
                 if (m_mac->GetWifiRemoteStationManager(linkId)->GetEmlsrEnabled(address))
                 {
+                    NS_LOG_DEBUG("Involved in DL TXOP: " << address);
                     emlsrClients.insert(address);
                 }
             }
@@ -317,6 +319,19 @@
 }
 
 void
+EhtFrameExchangeManager::ProtectionCompleted()
+{
+    NS_LOG_FUNCTION(this);
+
+    if (m_staMac && m_staMac->GetEmlsrManager())
+    {
+        m_staMac->GetEmlsrManager()->NotifyProtectionCompleted(m_linkId);
+    }
+
+    HeFrameExchangeManager::ProtectionCompleted();
+}
+
+void
 EhtFrameExchangeManager::ForwardPsduDown(Ptr<const WifiPsdu> psdu, WifiTxVector& txVector)
 {
     NS_LOG_FUNCTION(this << psdu << txVector);
@@ -331,6 +346,38 @@
 
     auto txDuration = WifiPhy::CalculateTxDuration(psdu, txVector, m_phy->GetPhyBand());
 
+    if (m_apMac && psdu->GetHeader(0).IsTrigger())
+    {
+        for (const auto& client : m_sentRtsTo)
+        {
+            if (!GetWifiRemoteStationManager()->GetEmlsrEnabled(client))
+            {
+                continue;
+            }
+            auto clientMld = GetWifiRemoteStationManager()->GetMldAddress(client);
+            NS_ASSERT(clientMld);
+
+            // block transmissions on the other EMLSR links of the EMLSR clients
+            for (uint8_t linkId = 0; linkId < m_apMac->GetNLinks(); ++linkId)
+            {
+                if (linkId != m_linkId &&
+                    m_mac->GetWifiRemoteStationManager(linkId)->GetEmlsrEnabled(*clientMld))
+                {
+                    m_mac->BlockUnicastTxOnLinks(WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                                 *clientMld,
+                                                 {linkId});
+                }
+            }
+        }
+    }
+
+    if (m_staMac && m_staMac->IsEmlsrLink(m_linkId) && psdu->GetAddr1() == m_bssid &&
+        psdu->GetHeader(0).IsRts())
+    {
+        NS_ASSERT(m_staMac->GetEmlsrManager());
+        m_staMac->GetEmlsrManager()->NotifyRtsSent(m_linkId, psdu, txVector);
+    }
+
     HeFrameExchangeManager::ForwardPsduDown(psdu, txVector);
     UpdateTxopEndOnTxStart(txDuration, psdu->GetDuration());
 
@@ -361,15 +408,18 @@
     else if (m_staMac && m_staMac->IsEmlsrLink(m_linkId) &&
              m_staMac->GetEmlsrManager()->GetInDeviceInterference())
     {
+        NS_ASSERT(m_staMac->GetEmlsrManager());
+        m_staMac->GetEmlsrManager()->NotifyInDeviceInterferenceStart(m_linkId, txDuration);
+
         for (const auto linkId : m_staMac->GetLinkIds())
         {
             if (auto phy = m_mac->GetWifiPhy(linkId);
                 phy && linkId != m_linkId && m_staMac->IsEmlsrLink(linkId))
             {
-                auto txPowerDbm = phy->GetPower(txVector.GetTxPowerLevel()) + phy->GetTxGain();
+                const auto txPower = phy->GetPower(txVector.GetTxPowerLevel()) + phy->GetTxGain();
                 // generate in-device interference on the other EMLSR link for the duration of this
                 // transmission
-                GenerateInDeviceInterference(linkId, txDuration, DbmToW(txPowerDbm));
+                GenerateInDeviceInterference(linkId, txDuration, DbmToW(txPower));
             }
         }
     }
@@ -387,16 +437,52 @@
 
     if (m_apMac)
     {
+        // check if this is a BSRP TF used as ICF for some EMLSR client
+        if (IsTrigger(psduMap))
+        {
+            CtrlTriggerHeader trigger;
+            psduMap.cbegin()->second->GetPayload(0)->PeekHeader(trigger);
+
+            if (trigger.IsBsrp())
+            {
+                auto recipients = GetTfRecipients(trigger);
+                for (const auto& client : recipients)
+                {
+                    if (!GetWifiRemoteStationManager()->GetEmlsrEnabled(client))
+                    {
+                        continue;
+                    }
+                    auto clientMld = GetWifiRemoteStationManager()->GetMldAddress(client);
+                    NS_ASSERT(clientMld);
+
+                    // block transmissions on the other EMLSR links of the EMLSR clients
+                    for (uint8_t linkId = 0; linkId < m_apMac->GetNLinks(); ++linkId)
+                    {
+                        if (linkId != m_linkId &&
+                            m_mac->GetWifiRemoteStationManager(linkId)->GetEmlsrEnabled(*clientMld))
+                        {
+                            m_mac->BlockUnicastTxOnLinks(
+                                WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                *clientMld,
+                                {linkId});
+                        }
+                    }
+                }
+            }
+        }
+
         // check if the EMLSR clients shall switch back to listening operation at the end of this
         // PPDU
         for (auto clientIt = m_protectedStas.begin(); clientIt != m_protectedStas.end();)
         {
             auto aid = GetWifiRemoteStationManager()->GetAssociationId(*clientIt);
+            const auto psduMapIt = psduMap.find(aid);
+            const auto aidNotFoundAndNotTf = (psduMapIt == psduMap.cend()) && !IsTrigger(psduMap);
+            // the PSDU to process: the one addressed to the given AID (if any) or the unique one
+            const auto psdu = (psduMapIt != psduMap.cend() ? psduMapIt : psduMap.cbegin())->second;
 
-            if (auto psduMapIt = psduMap.find(aid);
-                GetWifiRemoteStationManager()->GetEmlsrEnabled(*clientIt) &&
-                (psduMapIt == psduMap.cend() ||
-                 GetEmlsrSwitchToListening(psduMapIt->second, aid, *clientIt)))
+            if (GetWifiRemoteStationManager()->GetEmlsrEnabled(*clientIt) &&
+                (aidNotFoundAndNotTf || GetEmlsrSwitchToListening(psdu, aid, *clientIt)))
             {
                 EmlsrSwitchToListening(*clientIt, txDuration);
                 // this client is no longer involved in the current TXOP
@@ -411,15 +497,18 @@
     else if (m_staMac && m_staMac->IsEmlsrLink(m_linkId) &&
              m_staMac->GetEmlsrManager()->GetInDeviceInterference())
     {
+        NS_ASSERT(m_staMac->GetEmlsrManager());
+        m_staMac->GetEmlsrManager()->NotifyInDeviceInterferenceStart(m_linkId, txDuration);
+
         for (const auto linkId : m_staMac->GetLinkIds())
         {
             if (auto phy = m_mac->GetWifiPhy(linkId);
                 phy && linkId != m_linkId && m_staMac->IsEmlsrLink(linkId))
             {
-                auto txPowerDbm = phy->GetPower(txVector.GetTxPowerLevel()) + phy->GetTxGain();
+                const auto txPower = phy->GetPower(txVector.GetTxPowerLevel()) + phy->GetTxGain();
                 // generate in-device interference on the other EMLSR link for the duration of this
                 // transmission
-                GenerateInDeviceInterference(linkId, txDuration, DbmToW(txPowerDbm));
+                GenerateInDeviceInterference(linkId, txDuration, DbmToW(txPower));
             }
         }
     }
@@ -477,69 +566,137 @@
     HeFrameExchangeManager::IntraBssNavResetTimeout();
 }
 
-void
-EhtFrameExchangeManager::EmlsrSwitchToListening(const Mac48Address& address, const Time& delay)
+bool
+EhtFrameExchangeManager::UnblockEmlsrLinksIfAllowed(Mac48Address address)
 {
-    NS_LOG_FUNCTION(this << address << delay.As(Time::US));
+    NS_LOG_FUNCTION(this << address);
 
     auto mldAddress = GetWifiRemoteStationManager()->GetMldAddress(address);
     NS_ASSERT_MSG(mldAddress, "MLD address not found for " << address);
     NS_ASSERT_MSG(m_apMac, "This function shall only be called by AP MLDs");
+    std::set<uint8_t> linkIds{m_linkId};
+
+    /**
+     * Do nothing if the EMLSR client is involved in a DL or UL TXOP on another EMLSR link. This
+     * may happen, e.g., when the AP MLD sent an MU-RTS to multiple stations on this link, some of
+     * which responded, but this EMLSR client did not, e.g., because it concurrently started an UL
+     * TXOP on another link. The AP MLD then started a (long) DL MU transmission on this link,
+     * during which the EMLSR client completed the UL TXOP and started being involved in another
+     * DL or UL TXOP (note that DL TXOP is possible because the AP MLD considered the EMLSR client
+     * unprotected as soon as it detected the start of the previous UL TXOP). A Block Ack timeout
+     * for the EMLSR client occurs at the end of the DL MU transmission (which brings us here) and
+     * it may occur while the EMLSR client is still involved in a DL or UL TXOP.
+     *
+     *          ┌─────────────┐          ┌───────────────┐
+     *          │  MU-RTS to  │          │    Data to    │      BA timeout for us
+     *          │us and others│          │ us and others │        |
+     *  ────────┴─────────────┴┬────────┬┴───────────────┴┬───────┬──────────────
+     *  [this link]            │CTS from│                 │BA from│
+     *                         │ others │                 │ others│
+     *                         └────────┘                 └───────┘
+     *                                          ┌───────┐
+     *                     ┌───┐      ┌──┐      │ MU-RTS│     ┌──────┐
+     *  [other link]       │CTS│      │BA│      │ to us │     │ Data │
+     *  ─────────┬────────┬┴───┴┬────┬┴──┴──────┴───────┴┬───┬┴──────┴┬──┬───────
+     *           │   RTS  │     │Data│                   │CTS│        │BA│
+     *           │from us │     └────┘                   └───┘        └──┘
+     *           └────────┘
+     */
 
     for (uint8_t linkId = 0; linkId < m_apMac->GetNLinks(); ++linkId)
     {
-        if (auto ehtFem =
-                StaticCast<EhtFrameExchangeManager>(m_mac->GetFrameExchangeManager(linkId));
-            ehtFem->m_ongoingTxopEnd.IsPending() && ehtFem->m_txopHolder &&
+        if (!m_mac->GetWifiRemoteStationManager(linkId)->GetEmlsrEnabled(*mldAddress))
+        {
+            continue; // not an EMLSR link
+        }
+
+        auto ehtFem = StaticCast<EhtFrameExchangeManager>(m_mac->GetFrameExchangeManager(linkId));
+
+        if (ehtFem->m_ongoingTxopEnd.IsPending() && ehtFem->m_txopHolder &&
             m_mac->GetWifiRemoteStationManager(linkId)->GetMldAddress(*ehtFem->m_txopHolder) ==
                 mldAddress)
         {
-            // this EMLSR client is the holder of an UL TXOP, do not unblock links
-            return;
+            NS_LOG_DEBUG("EMLSR client " << *mldAddress << " is the holder of an UL TXOP on link "
+                                         << +linkId << ", do not unblock links");
+            return false;
         }
-    }
 
-    // this EMLSR client switches back to listening operation a transition delay
-    // after the given delay
-    auto emlCapabilities = GetWifiRemoteStationManager()->GetStationEmlCapabilities(address);
-    NS_ASSERT(emlCapabilities);
+        if (linkId == m_linkId)
+        {
+            // no need to check if the EMLSR client is involved in a DL TXOP on this link
+            continue;
+        }
 
-    std::set<uint8_t> linkIds;
-    for (uint8_t linkId = 0; linkId < m_mac->GetNLinks(); linkId++)
-    {
-        if (m_mac->GetWifiRemoteStationManager(linkId)->GetEmlsrEnabled(*mldAddress))
+        linkIds.insert(linkId);
+
+        if (auto linkAddr =
+                m_apMac->GetWifiRemoteStationManager(linkId)->GetAffiliatedStaAddress(*mldAddress);
+            linkAddr &&
+            (ehtFem->m_sentRtsTo.contains(*linkAddr) || ehtFem->m_sentFrameTo.contains(*linkAddr) ||
+             ehtFem->m_protectedStas.contains(*linkAddr)))
         {
-            linkIds.insert(linkId);
+            NS_LOG_DEBUG("EMLSR client " << address
+                                         << " has been sent an ICF, do not unblock links");
+            return false;
         }
     }
 
+    // unblock DL transmissions with reason USING_OTHER_EMLSR_LINK
+    m_mac->UnblockUnicastTxOnLinks(WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                   *mldAddress,
+                                   linkIds);
+    return true;
+}
+
+void
+EhtFrameExchangeManager::EmlsrSwitchToListening(Mac48Address address, const Time& delay)
+{
+    NS_LOG_FUNCTION(this << address << delay.As(Time::US));
+
+    auto mldAddress = GetWifiRemoteStationManager()->GetMldAddress(address);
+    NS_ASSERT_MSG(mldAddress, "MLD address not found for " << address);
+    NS_ASSERT_MSG(m_apMac, "This function shall only be called by AP MLDs");
+
     auto blockLinks = [=, this]() {
-        // the reason for blocking the other EMLSR links has changed now
-        m_mac->UnblockUnicastTxOnLinks(WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
-                                       *mldAddress,
-                                       linkIds);
+        if (!UnblockEmlsrLinksIfAllowed(address))
+        {
+            NS_LOG_DEBUG("Could not unblock transmissions to " << address);
+            return;
+        }
+
+        // this EMLSR client switches back to listening operation
+        std::set<uint8_t> linkIds;
+        for (uint8_t linkId = 0; linkId < m_mac->GetNLinks(); linkId++)
+        {
+            if (m_mac->GetWifiRemoteStationManager(linkId)->GetEmlsrEnabled(*mldAddress))
+            {
+                linkIds.insert(linkId);
+            }
+        }
 
         // block DL transmissions on this link until transition delay elapses
         m_mac->BlockUnicastTxOnLinks(WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY,
                                      *mldAddress,
                                      linkIds);
-    };
 
-    delay.IsZero() ? blockLinks() : static_cast<void>(Simulator::Schedule(delay, blockLinks));
+        auto unblockLinks = [=, this]() {
+            m_mac->UnblockUnicastTxOnLinks(WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY,
+                                           *mldAddress,
+                                           linkIds);
+        };
 
-    // unblock all EMLSR links when the transition delay elapses
-    auto unblockLinks = [=, this]() {
-        m_mac->UnblockUnicastTxOnLinks(WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY,
-                                       *mldAddress,
-                                       linkIds);
-    };
+        // unblock all EMLSR links when the transition delay elapses
+        auto emlCapabilities = GetWifiRemoteStationManager()->GetStationEmlCapabilities(address);
+        NS_ASSERT(emlCapabilities);
+        auto endDelay = CommonInfoBasicMle::DecodeEmlsrTransitionDelay(
+            emlCapabilities->get().emlsrTransitionDelay);
 
-    auto endDelay = delay + CommonInfoBasicMle::DecodeEmlsrTransitionDelay(
-                                emlCapabilities->get().emlsrTransitionDelay);
+        endDelay.IsZero() ? unblockLinks()
+                          : static_cast<void>(m_transDelayTimer[*mldAddress] =
+                                                  Simulator::Schedule(endDelay, unblockLinks));
+    };
 
-    endDelay.IsZero() ? unblockLinks()
-                      : static_cast<void>(m_transDelayTimer[*mldAddress] =
-                                              Simulator::Schedule(endDelay, unblockLinks));
+    delay.IsZero() ? blockLinks() : static_cast<void>(Simulator::Schedule(delay, blockLinks));
 }
 
 void
@@ -629,54 +786,89 @@
 }
 
 void
-EhtFrameExchangeManager::SendMuRts(const WifiTxParameters& txParams)
+EhtFrameExchangeManager::SetIcfPaddingAndTxVector(CtrlTriggerHeader& trigger,
+                                                  WifiTxVector& txVector) const
 {
-    NS_LOG_FUNCTION(this << &txParams);
+    NS_LOG_FUNCTION(this << trigger << txVector);
 
+    if (!trigger.IsMuRts() && !trigger.IsBsrp())
+    {
+        NS_LOG_INFO("Not an ICF");
+        return;
+    }
+
+    const auto recipients = GetTfRecipients(trigger);
     uint8_t maxPaddingDelay = 0;
+    bool isUnprotectedEmlsrDst = false;
 
-    // block transmissions on the other EMLSR links of the EMLSR clients
-    for (const auto& address : m_sentRtsTo)
+    for (const auto& address : recipients)
     {
-        if (!GetWifiRemoteStationManager()->GetEmlsrEnabled(address))
+        if (!GetWifiRemoteStationManager()->GetEmlsrEnabled(address) ||
+            m_protectedStas.contains(address))
         {
-            continue;
+            continue; // not an EMLSR client or EMLSR client already protected
         }
 
+        isUnprotectedEmlsrDst = true;
         auto emlCapabilities = GetWifiRemoteStationManager()->GetStationEmlCapabilities(address);
         NS_ASSERT(emlCapabilities);
         maxPaddingDelay = std::max(maxPaddingDelay, emlCapabilities->get().emlsrPaddingDelay);
+    }
 
-        auto mldAddress = GetWifiRemoteStationManager()->GetMldAddress(address);
-        NS_ASSERT(mldAddress);
-
-        for (uint8_t linkId = 0; linkId < m_apMac->GetNLinks(); linkId++)
-        {
-            if (linkId != m_linkId &&
-                m_mac->GetWifiRemoteStationManager(linkId)->GetEmlsrEnabled(*mldAddress))
-            {
-                m_mac->BlockUnicastTxOnLinks(WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
-                                             *mldAddress,
-                                             {linkId});
-            }
-        }
+    if (isUnprotectedEmlsrDst)
+    {
+        // The initial Control frame of frame exchanges shall be sent in the non-HT PPDU or
+        // non-HT duplicate PPDU format using a rate of 6 Mb/s, 12 Mb/s, or 24 Mb/s.
+        // (Sec. 35.3.17 of 802.11be D3.0)
+        GetWifiRemoteStationManager()->AdjustTxVectorForIcf(txVector);
     }
 
     // add padding (if needed)
     if (maxPaddingDelay > 0)
     {
-        NS_ASSERT(txParams.m_protection &&
-                  txParams.m_protection->method == WifiProtection::MU_RTS_CTS);
-        auto protection = static_cast<WifiMuRtsCtsProtection*>(txParams.m_protection.get());
-        NS_ASSERT(protection->muRts.IsMuRts());
-
         // see formula (35-1) in Sec. 35.5.2.2.3 of 802.11be D3.0
-        auto rate = protection->muRtsTxVector.GetMode().GetDataRate(protection->muRtsTxVector);
+        auto rate = txVector.GetMode().GetDataRate(txVector);
         std::size_t nDbps = rate / 1e6 * 4; // see Table 17-4 of 802.11-2020
-        protection->muRts.SetPaddingSize((1 << (maxPaddingDelay + 2)) * nDbps / 8);
+        trigger.SetPaddingSize((1 << (maxPaddingDelay + 2)) * nDbps / 8);
     }
+}
+
+void
+EhtFrameExchangeManager::ReceivedQosNullAfterBsrpTf(Mac48Address sender)
+{
+    NS_LOG_FUNCTION(this << sender);
 
-    HeFrameExchangeManager::SendMuRts(txParams);
+    // an EMLSR client responding to a BSRP TF must be considered protected
+    if (GetWifiRemoteStationManager()->GetEmlsrEnabled(sender))
+    {
+        m_protectedStas.insert(sender);
+    }
+
+    HeFrameExchangeManager::ReceivedQosNullAfterBsrpTf(sender);
+}
+
+bool
+EhtFrameExchangeManager::EmlsrClientCannotRespondToIcf() const
+{
+    NS_ASSERT(m_staMac);
+    if (m_staMac->IsEmlsrLink(m_linkId))
+    {
+        auto mainPhy = m_staMac->GetDevice()->GetPhy(m_staMac->GetEmlsrManager()->GetMainPhyId());
+
+        // while an ICF is being received on this link, an aux PHY that is not TX capable may get
+        // a TXOP on another link, release the channel and request the main PHY to switch channel.
+        // It may be decided to have the main PHY start a TXOP on the other link a PIFS after the
+        // channel switch (e.g., MAC header information is not used and AllowUlTxopInRx is true).
+        // Thus, when the ICF is received on this link, it is not dropped but, when the CTS must
+        // be transmitted, the main PHY has already started transmitting on the other link. In
+        // such a case, do not respond to the ICF.
+        if (mainPhy->IsStateSwitching() || m_mac->GetLinkForPhy(mainPhy) != m_linkId)
+        {
+            NS_LOG_DEBUG("Main PHY is switching or operating on another link, abort ICF response");
+            return true;
+        }
+    }
+    return false;
 }
 
 void
@@ -686,37 +878,122 @@
 {
     NS_LOG_FUNCTION(this << muRtsHdr << trigger << muRtsSnr);
 
-    NS_ASSERT(m_staMac);
-    if (auto emlsrManager = m_staMac->GetEmlsrManager())
+    if (EmlsrClientCannotRespondToIcf())
     {
-        auto mainPhy = m_staMac->GetDevice()->GetPhy(emlsrManager->GetMainPhyId());
+        return;
+    }
+    HeFrameExchangeManager::SendCtsAfterMuRts(muRtsHdr, trigger, muRtsSnr);
+}
 
-        // an aux PHY that is not TX capable may get a TXOP, release the channel and request
-        // the main PHY to switch channel. Shortly afterwards, the AP MLD may send an ICF, thus
-        // when the main PHY is scheduled to send the CTS, the main PHY may be switching channel
-        // or may be operating on another link
-        if (mainPhy->IsStateSwitching() || m_mac->GetLinkForPhy(mainPhy) != m_linkId)
+void
+EhtFrameExchangeManager::SendQosNullFramesInTbPpdu(const CtrlTriggerHeader& trigger,
+                                                   const WifiMacHeader& hdr)
+{
+    NS_LOG_FUNCTION(this << trigger << hdr);
+
+    if (trigger.IsBsrp() && EmlsrClientCannotRespondToIcf())
+    {
+        return;
+    }
+    HeFrameExchangeManager::SendQosNullFramesInTbPpdu(trigger, hdr);
+}
+
+void
+EhtFrameExchangeManager::SwitchToListeningOrUnblockLinks(const std::set<Mac48Address>& clients)
+{
+    NS_LOG_FUNCTION(this);
+
+    for (const auto& address : clients)
+    {
+        if (GetWifiRemoteStationManager()->GetEmlsrEnabled(address))
         {
-            NS_LOG_DEBUG("Main PHY is switching or operating on another link, abort sending CTS");
-            return;
+            // EMLSR client switched to listening operations if it was protected, otherwise
+            // simply unblock transmissions
+            m_protectedStas.contains(address) ? EmlsrSwitchToListening(address, Seconds(0))
+                                              : (void)(UnblockEmlsrLinksIfAllowed(address));
+            m_protectedStas.erase(address);
         }
     }
-    HeFrameExchangeManager::SendCtsAfterMuRts(muRtsHdr, trigger, muRtsSnr);
 }
 
 void
 EhtFrameExchangeManager::CtsAfterMuRtsTimeout(Ptr<WifiMpdu> muRts, const WifiTxVector& txVector)
 {
     NS_LOG_FUNCTION(this << *muRts << txVector);
+    SwitchToListeningOrUnblockLinks(m_sentRtsTo);
+    HeFrameExchangeManager::CtsAfterMuRtsTimeout(muRts, txVector);
+}
 
-    // check if all the clients solicited by the MU-RTS are EMLSR clients that have sent (or
-    // are sending) a frame to the AP
+bool
+EhtFrameExchangeManager::GetUpdateCwOnCtsTimeout() const
+{
+    NS_LOG_FUNCTION(this);
+
+    if (m_apMac)
+    {
+        if (const auto apEmlsrManager = m_apMac->GetApEmlsrManager();
+            apEmlsrManager && IsCrossLinkCollision(m_sentRtsTo))
+        {
+            return apEmlsrManager->UpdateCwAfterFailedIcf();
+        }
+    }
+
+    return HeFrameExchangeManager::GetUpdateCwOnCtsTimeout();
+}
+
+void
+EhtFrameExchangeManager::TbPpduTimeout(WifiPsduMap* psduMap, std::size_t nSolicitedStations)
+{
+    NS_LOG_FUNCTION(this << psduMap << nSolicitedStations);
+
+    const auto& staMissedTbPpduFrom = m_txTimer.GetStasExpectedToRespond();
+    const auto crossLinkCollision = IsCrossLinkCollision(staMissedTbPpduFrom);
+
+    if (staMissedTbPpduFrom.size() != nSolicitedStations)
+    {
+        // some STAs replied, hence the transmission succeeded. EMLSR clients that did not
+        // respond are switching back to listening operations
+        SwitchToListeningOrUnblockLinks(staMissedTbPpduFrom);
+    }
+
+    const auto apEmlsrManager = m_apMac->GetApEmlsrManager();
+    const auto updateFailedCw =
+        crossLinkCollision && apEmlsrManager ? apEmlsrManager->UpdateCwAfterFailedIcf() : true;
+    DoTbPpduTimeout(psduMap, nSolicitedStations, updateFailedCw);
+}
+
+void
+EhtFrameExchangeManager::BlockAcksInTbPpduTimeout(WifiPsduMap* psduMap,
+                                                  std::size_t nSolicitedStations)
+{
+    NS_LOG_FUNCTION(this << psduMap << nSolicitedStations);
+
+    const auto& staMissedTbPpduFrom = m_txTimer.GetStasExpectedToRespond();
+
+    if (staMissedTbPpduFrom.size() != nSolicitedStations)
+    {
+        // some STAs replied, hence the transmission succeeded. EMLSR clients that did not
+        // respond are switching back to listening operations
+        SwitchToListeningOrUnblockLinks(staMissedTbPpduFrom);
+    }
+
+    HeFrameExchangeManager::BlockAcksInTbPpduTimeout(psduMap, nSolicitedStations);
+}
+
+bool
+EhtFrameExchangeManager::IsCrossLinkCollision(
+    const std::set<Mac48Address>& staMissedResponseFrom) const
+{
+    NS_LOG_FUNCTION(this << staMissedResponseFrom.size());
+
+    // check if all the clients that did not respond to the ICF are EMLSR clients that have sent
+    // (or are sending) a frame to the AP on another link
     auto crossLinkCollision = true;
 
     // we blocked transmissions on the other EMLSR links for the EMLSR clients we sent the ICF to.
-    // Given that no client responded, we can unblock transmissions for a client if there is no
-    // ongoing UL TXOP held by that client
-    for (const auto& address : m_sentRtsTo)
+    // For clients that did not respond, we can unblock transmissions if there is no ongoing
+    // UL TXOP held by that client
+    for (const auto& address : staMissedResponseFrom)
     {
         if (!GetWifiRemoteStationManager()->GetEmlsrEnabled(address))
         {
@@ -730,7 +1007,8 @@
         std::set<uint8_t> linkIds; // all EMLSR links of EMLSR client
         for (uint8_t linkId = 0; linkId < m_apMac->GetNLinks(); linkId++)
         {
-            if (m_mac->GetWifiRemoteStationManager(linkId)->GetEmlsrEnabled(*mldAddress))
+            if (m_mac->GetWifiRemoteStationManager(linkId)->GetEmlsrEnabled(*mldAddress) &&
+                linkId != m_linkId)
             {
                 linkIds.insert(linkId);
             }
@@ -765,16 +1043,9 @@
         {
             crossLinkCollision = false;
         }
-
-        linkIds.erase(m_linkId);
-        m_mac->UnblockUnicastTxOnLinks(WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
-                                       *mldAddress,
-                                       linkIds);
     }
 
-    auto updateFailedCw =
-        crossLinkCollision ? m_apMac->GetApEmlsrManager()->UpdateCwAfterFailedIcf() : true;
-    DoCtsAfterMuRtsTimeout(muRts, txVector, updateFailedCw);
+    return crossLinkCollision;
 }
 
 void
@@ -904,9 +1175,9 @@
 }
 
 void
-EhtFrameExchangeManager::TransmissionFailed()
+EhtFrameExchangeManager::TransmissionFailed(bool forceCurrentCw)
 {
-    NS_LOG_FUNCTION(this);
+    NS_LOG_FUNCTION(this << forceCurrentCw);
 
     if (m_staMac && m_staMac->IsEmlsrLink(m_linkId) &&
         m_staMac->GetEmlsrManager()->GetElapsedMediumSyncDelayTimer(m_linkId))
@@ -916,7 +1187,7 @@
         m_staMac->GetEmlsrManager()->DecrementMediumSyncDelayNTxops(m_linkId);
     }
 
-    HeFrameExchangeManager::TransmissionFailed();
+    HeFrameExchangeManager::TransmissionFailed(forceCurrentCw);
 }
 
 void
@@ -1040,6 +1311,13 @@
             UpdateTxopEndOnRxEnd(psdu->GetDuration());
         }
     }
+
+    if (m_staMac && m_icfReceived)
+    {
+        // notify the EMLSR manager
+        m_staMac->GetEmlsrManager()->NotifyIcfReceived(m_linkId);
+        m_icfReceived = false;
+    }
 }
 
 bool
@@ -1083,6 +1361,19 @@
             m_mac->BlockUnicastTxOnLinks(WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
                                          *mldAddress,
                                          {linkId});
+
+            // the AP MLD may have sent an ICF to the EMLSR client on this link while the EMLSR
+            // client was starting a TXOP on another link. To be safe, besides blocking
+            // transmissions, remove the EMLSR client from the protected stations on this link
+            auto linkAddr =
+                m_mac->GetWifiRemoteStationManager(linkId)->GetAffiliatedStaAddress(*mldAddress);
+            NS_ASSERT(linkAddr.has_value());
+            auto ehtFem =
+                StaticCast<EhtFrameExchangeManager>(m_mac->GetFrameExchangeManager(linkId));
+            NS_LOG_DEBUG("Remove " << *linkAddr << " from protected STAs");
+            ehtFem->m_protectedStas.erase(*linkAddr);
+            ehtFem->m_sentRtsTo.erase(*linkAddr);
+            ehtFem->m_sentFrameTo.erase(*linkAddr);
         }
     }
 
@@ -1127,19 +1418,13 @@
                                      const WifiTxVector& txVector,
                                      bool inAmpdu)
 {
+    NS_LOG_FUNCTION(this << *mpdu << rxSignalInfo << txVector << inAmpdu);
+
     // The received MPDU is either broadcast or addressed to this station
     NS_ASSERT(mpdu->GetHeader().GetAddr1().IsGroup() || mpdu->GetHeader().GetAddr1() == m_self);
 
     const auto& hdr = mpdu->GetHeader();
-
-    if (m_apMac)
-    {
-        // if the AP MLD received an MPDU from an EMLSR client that is starting an UL TXOP,
-        // block transmissions to the EMLSR client on other links
-        CheckEmlsrClientStartingTxop(hdr, txVector);
-    }
-
-    bool icfReceived = false;
+    const auto sender = hdr.GetAddr2();
 
     if (hdr.IsTrigger())
     {
@@ -1153,13 +1438,14 @@
 
         if (hdr.GetAddr1() != m_self &&
             (!hdr.GetAddr1().IsBroadcast() || !m_staMac->IsAssociated() ||
-             hdr.GetAddr2() != m_bssid // not sent by the AP this STA is associated with
+             sender != m_bssid // not sent by the AP this STA is associated with
              || trigger.FindUserInfoWithAid(m_staMac->GetAssociationId()) == trigger.end()))
         {
             return; // not addressed to us
         }
 
-        if (trigger.IsMuRts() && m_staMac->IsEmlsrLink(m_linkId))
+        if ((trigger.IsMuRts() || trigger.IsBsrp()) && !m_ongoingTxopEnd.IsPending() &&
+            m_staMac->IsEmlsrLink(m_linkId))
         {
             // this is an initial Control frame
             if (DropReceivedIcf())
@@ -1170,7 +1456,7 @@
             auto emlsrManager = m_staMac->GetEmlsrManager();
             NS_ASSERT(emlsrManager);
 
-            icfReceived = true;
+            m_icfReceived = true;
 
             // we just got involved in a DL TXOP. Check if we are still involved in the TXOP in a
             // SIFS (we are expected to reply by sending a CTS frame)
